/*
 * ioGame
 * Copyright (C) 2021 - 2023  渔民小镇 （262610965@qq.com、luoyizhu@gmail.com） . All Rights Reserved.
 * # iohao.com . 渔民小镇
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.iohao.mmo.equip.client;

import com.iohao.game.action.skeleton.core.CmdInfo;
import com.iohao.game.action.skeleton.core.DataCodecKit;
import com.iohao.game.action.skeleton.core.flow.FlowContext;
import com.iohao.game.action.skeleton.protocol.ResponseMessage;
import com.iohao.mmo.common.provide.client.ExchangeKit;
import com.iohao.mmo.equip.cmd.EquipCmd;
import com.iohao.mmo.equip.proto.CreateEquipMessage;
import com.iohao.mmo.equip.proto.EquipResetMessage;
import com.iohao.mmo.equip.proto.NewEquipMessage;
import lombok.experimental.UtilityClass;

/**
 * 装备模块，对外提供的访问 api
 *
 * @author 唐斌
 * @date 2023-08-15
 */
@UtilityClass
public class EquipExchange {
    public void resetEquip(EquipResetMessage equipResetMessage, FlowContext flowContext) {
        CmdInfo cmdInfo = EquipCmd.of(EquipCmd.resetEquip);
        ExchangeKit.invokeModuleVoidMessage(flowContext, cmdInfo, equipResetMessage);
    }

    public NewEquipMessage createEquip(CreateEquipMessage createEquipMessage, FlowContext flowContext) {

        CmdInfo cmdInfo = EquipCmd.of(EquipCmd.createEquip);

        ResponseMessage responseMessage = ExchangeKit.invokeModuleMessage(flowContext, cmdInfo, createEquipMessage);

        return DataCodecKit.decode(responseMessage.getData(), NewEquipMessage.class);
    }
}
